diff --git a/src/libs/zbxdbcache/dbconfig.c b/src/libs/zbxdbcache/dbconfig.c
index ffe05ba..1f65542 100644
--- a/src/libs/zbxdbcache/dbconfig.c
+++ b/src/libs/zbxdbcache/dbconfig.c
@@ -10080,163 +9919,56 @@ int	DCreset_hosts_availability(zbx_vector_ptr_t *hosts)
 
 	while (NULL != (host = (ZBX_DC_HOST *)zbx_hashset_iter_next(&iter)))
 	{
-		int	items_num = 0, snmp_items_num = 0, ipmi_items_num = 0, jmx_items_num = 0;
-
-		/* On server skip hosts handled by proxies. They are handled directly */
-		/* when receiving hosts' availability data from proxies.              */
-		/* Unless a host was just (re)assigned to a proxy or the proxy has    */
-		/* not updated its status during the maximum proxy heartbeat period.  */
-		/* In this case reset all interfaces to unknown status.               */
-		if (0 == host->reset_availability &&
-				0 != (program_type & ZBX_PROGRAM_TYPE_SERVER) && 0 != host->proxy_hostid)
-		{
-			ZBX_DC_PROXY	*proxy;
-
-			if (NULL != (proxy = (ZBX_DC_PROXY *)zbx_hashset_search(&config->proxies, &host->proxy_hostid)))
-			{
-				/* SEC_PER_MIN is a tolerance interval, it was chosen arbitrarily */
-				if (ZBX_PROXY_HEARTBEAT_FREQUENCY_MAX + SEC_PER_MIN >= now - proxy->lastaccess)
-					continue;
-			}
-
-			host->reset_availability = 1;
-		}
-
-		if (NULL == ha)
-			ha = (zbx_host_availability_t *)zbx_malloc(NULL, sizeof(zbx_host_availability_t));
-
-		zbx_host_availability_init(ha, host->hostid);
+		if (0 == host->proxy_hostid)
+			continue;
 
-		if (0 == host->reset_availability)
+		if (NULL != (proxy = (ZBX_DC_PROXY *)zbx_hashset_search(&config->proxies, &host->proxy_hostid)))
 		{
-			items_num = host->items_num;
-			snmp_items_num = host->snmp_items_num;
-			ipmi_items_num = host->ipmi_items_num;
-			jmx_items_num = host->jmx_items_num;
+			/* SEC_PER_MIN is a tolerance interval, it was chosen arbitrarily */
+			if (ZBX_PROXY_HEARTBEAT_FREQUENCY_MAX + SEC_PER_MIN >= now - proxy->lastaccess)
+				continue;
 		}
 
-		if (0 == items_num && HOST_AVAILABLE_UNKNOWN != host->available)
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_ZABBIX], HOST_AVAILABLE_UNKNOWN, "", 0, 0);
-
-		if (0 == snmp_items_num && HOST_AVAILABLE_UNKNOWN != host->snmp_available)
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_SNMP], HOST_AVAILABLE_UNKNOWN, "", 0, 0);
-
-		if (0 == ipmi_items_num && HOST_AVAILABLE_UNKNOWN != host->ipmi_available)
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_IPMI], HOST_AVAILABLE_UNKNOWN, "", 0, 0);
-
-		if (0 == jmx_items_num && HOST_AVAILABLE_UNKNOWN != host->jmx_available)
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_JMX], HOST_AVAILABLE_UNKNOWN, "", 0, 0);
+		if (NULL == (host_ifstatus = zbx_hashset_search(&config->hosts_ifstatus, &host->hostid)))
+			continue;
 
-		if (SUCCEED == zbx_host_availability_is_set(ha))
+		for (i = 0; i < host_ifstatus->ifs.values_num; i++)
 		{
-			if (SUCCEED == DChost_set_availability(host, now, ha))
-			{
-				zbx_vector_ptr_append(hosts, ha);
-				ha = NULL;
-			}
-			else
-				zbx_host_availability_clean(ha);
+			ifstatus = (zbx_dc_ifstatus_t *)host_ifstatus->ifs.values[i];
+			ifstatus->agent.available = HOST_AVAILABLE_UNKNOWN;
+			zbx_strpool_release(ifstatus->agent.error);
+			ifstatus->agent.error = (char *)zbx_strpool_intern("");
 		}
 
-		host->reset_availability = 0;
-	}
-	UNLOCK_CACHE;
-
-	zbx_free(ha);
-
-	zbx_vector_ptr_sort(hosts, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
-
-	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() hosts:%d", __function_name, hosts->values_num);
-
-	return 0 == hosts->values_num ? FAIL : SUCCEED;
-}
-
-/******************************************************************************
- *                                                                            *
- * Function: DCget_hosts_availability                                         *
- *                                                                            *
- * Purpose: gets availability data for hosts with availability data changed   *
- *          in period from last availability update to the specified          *
- *          timestamp                                                         *
- *                                                                            *
- * Parameters: hosts - [OUT] changed host availability data                   *
- *             ts    - [OUT] the availability diff timestamp                  *
- *                                                                            *
- * Return value: SUCCEED - availability was changed for at least one host     *
- *               FAIL    - no host availability was changed                   *
- *                                                                            *
- ******************************************************************************/
-int	DCget_hosts_availability(zbx_vector_ptr_t *hosts, int *ts)
-{
-	const char		*__function_name = "DCget_hosts_availability";
-	ZBX_DC_HOST		*host;
-	zbx_hashset_iter_t	iter;
-	zbx_host_availability_t	*ha = NULL;
-
-	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
-
-	LOCK_CACHE;
-
-	*ts = time(NULL);
-
-	zbx_hashset_iter_reset(&config->hosts, &iter);
-
-	while (NULL != (host = (ZBX_DC_HOST *)zbx_hashset_iter_next(&iter)))
-	{
-		if (config->availability_diff_ts <= host->availability_ts && host->availability_ts < *ts)
-		{
-			ha = (zbx_host_availability_t *)zbx_malloc(NULL, sizeof(zbx_host_availability_t));
-			zbx_host_availability_init(ha, host->hostid);
-
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_ZABBIX], host->available, host->error,
-					host->errors_from, host->disable_until);
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_SNMP], host->snmp_available, host->snmp_error,
-					host->snmp_errors_from, host->snmp_disable_until);
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_IPMI], host->ipmi_available, host->ipmi_error,
-					host->ipmi_errors_from, host->ipmi_disable_until);
-			zbx_agent_availability_init(&ha->agents[ZBX_AGENT_JMX], host->jmx_available, host->jmx_error,
-					host->jmx_errors_from, host->jmx_disable_until);
-
-			zbx_vector_ptr_append(hosts, ha);
-		}
+		zbx_hashset_insert(&config->hosts_availability, &host->hostid, sizeof(host->hostid));
 	}
 
 	UNLOCK_CACHE;
 
-	zbx_vector_ptr_sort(hosts, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
-
-	zabbix_log(LOG_LEVEL_DEBUG, "End of %s() hosts:%d", __function_name, hosts->values_num);
-
-	return 0 == hosts->values_num ? FAIL : SUCCEED;
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
 }
 
 /******************************************************************************
  *                                                                            *
- * Function: DCtouch_hosts_availability                                       *
+ * Function: zbx_dc_refresh_hosts_availability                                *
  *                                                                            *
- * Purpose: sets availability timestamp to current time for the specified     *
- *          hosts                                                             *
+ * Purpose: forces host availability to be refreshed                          *
  *                                                                            *
  * Parameters: hostids - [IN] the host identifiers                            *
  *                                                                            *
  ******************************************************************************/
-void	DCtouch_hosts_availability(const zbx_vector_uint64_t *hostids)
+void	zbx_dc_refresh_hosts_availability(const zbx_vector_uint64_t *hostids)
 {
-	const char	*__function_name = "DCtouch_hosts_availability";
-	ZBX_DC_HOST	*dc_host;
-	int		i, now;
+	const char	*__function_name = "zbx_dc_refresh_hosts_availability";
 
-	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hostids:%d", __function_name, hostids->values_num);
+	int		i;
 
-	now = time(NULL);
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s() hostids:%d", __function_name, hostids->values_num);
 
 	LOCK_CACHE;
 
 	for (i = 0; i < hostids->values_num; i++)
-	{
-		if (NULL != (dc_host = zbx_hashset_search(&config->hosts, &hostids->values[i])))
-			dc_host->availability_ts = now;
-	}
+		zbx_hashset_insert(&config->hosts_availability, &hostids->values[i], sizeof(hostids->values[i]));
 
 	UNLOCK_CACHE;
 
@@ -10478,24 +10210,6 @@ void	zbx_dc_get_actions_eval(zbx_vector_ptr_t *actions, zbx_hashset_t *uniq_cond
 
 /******************************************************************************
  *                                                                            *
- * Function: zbx_set_availability_update_ts                                   *
- *                                                                            *
- * Purpose: sets timestamp of the last availability update                    *
- *                                                                            *
- * Parameter: ts - [IN] the last availability update timestamp                *
- *                                                                            *
- * Comments: This function is used only by proxies when preparing host        *
- *           availability data to be sent to server.                          *
- *                                                                            *
- ******************************************************************************/
-void	zbx_set_availability_diff_ts(int ts)
-{
-	/* this data can't be accessed simultaneously from multiple processes - locking is not necessary */
-	config->availability_diff_ts = ts;
-}
-
-/******************************************************************************
- *                                                                            *
  * Function: corr_condition_clean                                             *
  *                                                                            *
  * Purpose: frees correlation condition                                       *
@@ -11404,3 +11118,352 @@ void	zbx_dc_get_proxy_lastaccess(zbx_vector_uint64_pair_t *lastaccess)
 		zbx_vector_uint64_pair_sort(lastaccess, ZBX_DEFAULT_UINT64_COMPARE_FUNC);
 	}
 }
+
+/******************************************************************************
+ *                                                                            *
+ * Function: dc_get_aggregate_host_availability                               *
+ *                                                                            *
+ * Purpose: calculates aggregated availability by interface types for the     *
+ *          specified host                                                    *
+ *                                                                            *
+ * Parameter: hostid - [IN] the host identifier                               *
+ *            agents - [OUT] the availability status for all agent types      *
+ *                           (see ZBX_AGENT_  defines)                        *
+ *                                                                            *
+ * Comments: The status aggregation rules for an interface type are:          *
+ *              unknown   - no interfaces                                     *
+ *              unset     - only interfaces with unset status                 *
+ *              unknown   - interfaces with unset or unknown statuses         *
+ *              true      - at least one interface with true status and no    *
+ *                          interfaces with false status                      *
+ *              false     - at least one interface with false status and no   *
+ *                          interfaces with true status                       *
+ *              partial   - at least one interface with false status and one  *
+ *                          interface with true status                        *
+ *                                                                            *
+ ******************************************************************************/
+static void	dc_get_aggregate_host_availability(zbx_uint64_t hostid, zbx_agent_status_t *agents)
+{
+	zbx_dc_host_ifstatus_t	*host_ifstatus;
+	zbx_dc_ifstatus_t	*ifstatus;
+	zbx_agent_status_t	*agent;
+	int			i, available[ZBX_AGENT_MAX] = {-1, -1, -1, -1};
+
+	if (NULL == (host_ifstatus = zbx_hashset_search(&config->hosts_ifstatus, &hostid)))
+		return;
+
+	for (i = 0; i < host_ifstatus->ifs.values_num; i++)
+	{
+		ifstatus = (zbx_dc_ifstatus_t *)host_ifstatus->ifs.values[i];
+
+		if (HOST_AVAILABLE_UNSET == ifstatus->agent.available)
+		{
+			if (-1 == available[ifstatus->type])
+				available[ifstatus->type] = HOST_AVAILABLE_UNSET;
+			continue;
+		}
+
+		agent = &agents[ifstatus->type];
+
+		if (-1 == available[ifstatus->type])
+			available[ifstatus->type] = ifstatus->agent.available;
+		else
+			available[ifstatus->type] |= ifstatus->agent.available;
+
+		if ('\0' != *ifstatus->agent.error)
+		{
+			if (NULL == agent->error)
+				agent->error = zbx_dsprintf(agent->error, "%s", ifstatus->agent.error);
+			else
+				agent->error = zbx_strdcatf(agent->error, "\n%s", ifstatus->agent.error);
+		}
+	}
+
+	for (i = 0; i < ZBX_AGENT_MAX; i++)
+	{
+		if (-1 != available[i])
+			agents[i].available = available[i];
+	}
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: dc_update_host_availability                                      *
+ *                                                                            *
+ * Purpose: updates host availability in configuration cache                  *
+ *                                                                            *
+ * Parameters: agent         - [IN] the agent status data to set              *
+ *             available     - [OUT] the agent availability                   *
+ *             disable_until - [OUT] the time until agent can be polled       *
+ *             errors_from   - [OUT] the time of the first error              *
+ *             error         - [OUT] the error description                    *
+ *             update        - [OUT] the updated agent status data            *
+ *                                                                            *
+ * Return value: Succeed if any field was updated.                            *
+ *                                                                            *
+ * Comments: Only the fields that are different are updated and corresponding *
+ *           update flags set.                                                *
+ *                                                                            *
+ ******************************************************************************/
+static int	dc_update_host_availability(const zbx_agent_status_t *agent, unsigned char *available,
+		const char **error, zbx_agent_status_update_t *update)
+{
+	const char	*agent_error;
+
+	if (HOST_AVAILABLE_UNSET == agent->available)
+		return FAIL;
+
+	update->flags = ZBX_AGENT_STATUS_NONE;
+
+	if (agent->available != *available)
+	{
+		*available = agent->available;
+		update->available = agent->available;
+		update->flags |= ZBX_AGENT_STATUS_AVAILABLE;
+	}
+
+	agent_error = ZBX_NULL2EMPTY_STR(agent->error);
+
+	if (0 != strcmp(agent_error, *error))
+	{
+		zbx_strpool_release(*error);
+		*error = zbx_strpool_intern(agent_error);
+		update->error = zbx_strdup(NULL, agent_error);
+		update->flags |= ZBX_AGENT_STATUS_ERROR;
+	}
+
+	return (ZBX_AGENT_STATUS_NONE == update->flags ? FAIL : SUCCEED);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: dc_create_agent_status_update                                    *
+ *                                                                            *
+ * Purpose: creates agent status update                                       *
+ *                                                                            *
+ * Parameters: hostid     - [IN] the host identifier                          *
+ *             src        - [IN] the agent status update to add               *
+ *             agent_type - [IN] the agent type (see ZBX_AGENT_ defines)      *
+ *                                                                            *
+ ******************************************************************************/
+static zbx_agent_status_update_t	*dc_create_agent_status_update(zbx_uint64_t hostid,
+		const zbx_agent_status_update_t *src, unsigned char agent_type)
+{
+	zbx_agent_status_update_t	*update;
+
+	update = (zbx_agent_status_update_t *)zbx_malloc(NULL, sizeof(zbx_agent_status_update_t));
+	update->hostid = hostid;
+	update->type = agent_type;
+	update->flags = src->flags;
+	update->available = src->available;
+	update->error = src->error;
+
+	return update;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_dc_get_host_availability_updates                             *
+ *                                                                            *
+ * Purpose: gets host availability changes                                    *
+ *                                                                            *
+ * Parameters: updates - [OUT] the host availability updates                  *
+ *                                                                            *
+ ******************************************************************************/
+int	zbx_dc_get_host_availability_updates(zbx_vector_ptr_t *updates)
+{
+	ZBX_DC_HOST			*host;
+	zbx_uint64_t			*phostid;
+	zbx_hashset_iter_t		iter;
+	zbx_agent_status_t		agents[ZBX_AGENT_MAX];
+	int				i, ret = FAIL;
+	zbx_agent_status_update_t	update;
+
+	LOCK_CACHE;
+
+	if (0 == config->hosts_availability.num_data)
+		goto out;
+
+	zbx_hashset_iter_reset(&config->hosts_availability, &iter);
+	while (NULL != (phostid = zbx_hashset_iter_next(&iter)))
+	{
+		if (NULL == (host = (ZBX_DC_HOST *)zbx_hashset_search(&config->hosts, phostid)))
+			continue;
+
+		memset(agents, 0, sizeof(agents));
+		dc_get_aggregate_host_availability(*phostid, agents);
+
+		if (SUCCEED == dc_update_host_availability(&agents[ZBX_AGENT_ZABBIX], &host->available, &host->error,
+				&update))
+		{
+			zbx_vector_ptr_append(updates, dc_create_agent_status_update(*phostid, &update, ZBX_AGENT_ZABBIX));
+		}
+
+		if (SUCCEED == dc_update_host_availability(&agents[ZBX_AGENT_SNMP], &host->snmp_available,
+				&host->snmp_error, &update))
+		{
+			zbx_vector_ptr_append(updates, dc_create_agent_status_update(*phostid, &update, ZBX_AGENT_SNMP));
+		}
+
+		if (SUCCEED == dc_update_host_availability(&agents[ZBX_AGENT_IPMI], &host->ipmi_available,
+				&host->ipmi_error, &update))
+		{
+			zbx_vector_ptr_append(updates, dc_create_agent_status_update(*phostid, &update, ZBX_AGENT_IPMI));
+		}
+
+		if (SUCCEED == dc_update_host_availability(&agents[ZBX_AGENT_JMX], &host->jmx_available,
+				&host->jmx_error, &update))
+		{
+			zbx_vector_ptr_append(updates, dc_create_agent_status_update(*phostid, &update, ZBX_AGENT_JMX));
+		}
+
+		for (i = 0; i < ZBX_AGENT_MAX; i++)
+			zbx_free(agents[i].error);
+	}
+
+	zbx_hashset_clear(&config->hosts_availability);
+
+	if (0 != updates->values_num)
+		ret = SUCCEED;
+out:
+	UNLOCK_CACHE;
+
+	return ret;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_refresh_host_availability                                    *
+ *                                                                            *
+ * Purpose: force host availability status refresh for the hosts in updates   *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_refresh_host_availability(const zbx_vector_ptr_t *updates)
+{
+	int				i;
+	zbx_uint64_t			hostid = 0;
+	const zbx_agent_status_update_t	*update;
+
+	LOCK_CACHE;
+
+	for (i = 0; i < updates->values_num; i++)
+	{
+		update = (const zbx_agent_status_update_t *)updates->values[i];
+
+		if (update->hostid == hostid)
+			continue;
+
+		hostid = update->hostid;
+		zbx_hashset_insert(&config->hosts_availability, &hostid, sizeof(hostid));
+	}
+
+	UNLOCK_CACHE;
+}
+
+void	zbx_dc_update_proxy_host_availability(const zbx_vector_ptr_t *updates)
+{
+	int				i, j;
+	zbx_uint64_t			hostid = 0;
+	const zbx_agent_status_update_t	*update;
+	zbx_dc_host_ifstatus_t		*host_ifstatus = NULL;
+	zbx_dc_ifstatus_t		*ifstatus;
+	const char			*error;
+
+	LOCK_CACHE;
+
+	for (i = 0; i < updates->values_num; i++)
+	{
+		update = (const zbx_agent_status_update_t *)updates->values[i];
+
+		if (update->hostid != hostid)
+		{
+			hostid = update->hostid;
+			host_ifstatus = (zbx_dc_host_ifstatus_t *)zbx_hashset_search(&config->hosts_ifstatus, &hostid);
+		}
+
+		if (NULL == host_ifstatus)
+			continue;
+
+		for (j = 0; j < host_ifstatus->ifs.values_num; j++)
+		{
+			ifstatus = (zbx_dc_ifstatus_t *)host_ifstatus->ifs.values[j];
+
+			if (update->type == ifstatus->type)
+			{
+				error = (0 != (update->flags & ZBX_AGENT_STATUS_ERROR) ? update->error : "");
+				dc_set_agent_status(hostid, &ifstatus->agent, update->available, 0, 0, error);
+				break;
+			}
+		}
+	}
+
+	UNLOCK_CACHE;
+}
+
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_dc_get_host_availability                                     *
+ *                                                                            *
+ * Purpose: returns host agent availability                                   *
+ *                                                                            *
+ * Parameter: hostid - [IN] the host identifier                               *
+ *            agents - [OUT] the agent availability data                      *
+ *                                                                            *
+ * Comments: The agent availability data might contain error message that has *
+ *           to be freed by the caller. Use zbx_dc_clean_host_availability()  *
+ *           function for it.                                                 *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_dc_get_host_availability(zbx_uint64_t hostid, zbx_agent_status_t *agents)
+{
+	ZBX_DC_HOST	*host;
+
+	memset(agents, 0, sizeof(zbx_agent_status_t) * ZBX_AGENT_MAX);
+
+	LOCK_CACHE;
+
+	if (NULL != (host = (ZBX_DC_HOST *)zbx_hashset_search(&config->hosts, &hostid)))
+		 dc_get_aggregate_host_availability(hostid, agents);
+
+	UNLOCK_CACHE;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_dc_clean_host_availability                                   *
+ *                                                                            *
+ * Purpose: cleans host agent availability data returned by                   *
+ *          zbx_dc_get_host_availability                                      *
+ *                                                                            *
+ * Parameter: lastaccess - [OUT] last access updates for proxies that need    *
+ *                               to be synced with database, sorted by        *
+ *                               hostid                                       *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_dc_clean_host_availability(zbx_agent_status_t *agents)
+{
+	int	i;
+
+	for (i = 0; i < ZBX_AGENT_MAX; i++)
+	{
+		if (HOST_AVAILABLE_FALSE == agents[i].available)
+			zbx_free(agents[i].error);
+	}
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_agent_status_update_free                                     *
+ *                                                                            *
+ * Purpose: frees agent status update data                                    *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_agent_status_update_free(void *data)
+{
+	zbx_agent_status_update_t	*update = (zbx_agent_status_update_t *)data;
+
+	if (0 != (update->flags & ZBX_AGENT_STATUS_ERROR))
+		zbx_free(update->error);
+	zbx_free(update);
+}
diff --git a/src/libs/zbxdbcache/dbconfig.h b/src/libs/zbxdbcache/dbconfig.h
index fb4e4f6..002f7bd 100644
--- a/src/libs/zbxdbcache/dbconfig.h
+++ b/src/libs/zbxdbcache/dbconfig.h
@@ -26,6 +26,25 @@
 
 typedef struct
 {
+	zbx_uint64_t		interfaceid;
+	zbx_hash_t		agent_hash;
+
+	int			refcount;
+	unsigned char		type;
+
+	zbx_agent_status_t	agent;
+}
+zbx_dc_ifstatus_t;
+
+typedef struct
+{
+	zbx_uint64_t		hostid;
+	zbx_vector_ptr_t	ifs;
+}
+zbx_dc_host_ifstatus_t;
+
+typedef struct
+{
 	zbx_uint64_t		triggerid;
 	const char		*description;
 	const char		*expression;
@@ -70,34 +89,35 @@ ZBX_DC_FUNCTION;
 
 typedef struct
 {
-	zbx_uint64_t		itemid;
-	zbx_uint64_t		hostid;
-	zbx_uint64_t		interfaceid;
-	zbx_uint64_t		lastlogsize;
-	zbx_uint64_t		valuemapid;
-	const char		*key;
-	const char		*port;
-	const char		*error;
-	const char		*delay;
-	ZBX_DC_TRIGGER		**triggers;
-	int			nextcheck;
-	int			lastclock;
-	int			mtime;
-	int			data_expected_from;
-	int			history_sec;
-	unsigned char		history;
-	unsigned char		type;
-	unsigned char		value_type;
-	unsigned char		poller_type;
-	unsigned char		state;
-	unsigned char		db_state;
-	unsigned char		inventory_link;
-	unsigned char		location;
-	unsigned char		flags;
-	unsigned char		status;
-	unsigned char		queue_priority;
-	unsigned char		schedulable;
-	unsigned char		update_triggers;
+	zbx_uint64_t			itemid;
+	zbx_uint64_t			hostid;
+	zbx_uint64_t			interfaceid;
+	zbx_uint64_t			lastlogsize;
+	zbx_uint64_t			valuemapid;
+	const char			*key;
+	const char			*port;
+	const char			*error;
+	const char			*delay;
+	ZBX_DC_TRIGGER			**triggers;
+	zbx_dc_ifstatus_t		*ifstatus;
+	int				nextcheck;
+	int				lastclock;
+	int				mtime;
+	int				data_expected_from;
+	int				history_sec;
+	unsigned char			history;
+	unsigned char			type;
+	unsigned char			value_type;
+	unsigned char			poller_type;
+	unsigned char			state;
+	unsigned char			db_state;
+	unsigned char			inventory_link;
+	unsigned char			location;
+	unsigned char			flags;
+	unsigned char			status;
+	unsigned char			queue_priority;
+	unsigned char			schedulable;
+	unsigned char			update_triggers;
 }
 ZBX_DC_ITEM;
 
@@ -284,14 +304,6 @@ typedef struct
 	const char	*name;
 	int		maintenance_from;
 	int		data_expected_from;
-	int		errors_from;
-	int		disable_until;
-	int		snmp_errors_from;
-	int		snmp_disable_until;
-	int		ipmi_errors_from;
-	int		ipmi_disable_until;
-	int		jmx_errors_from;
-	int		jmx_disable_until;
 
 	/* item statistics per interface type */
 	int		items_num;
@@ -299,9 +311,6 @@ typedef struct
 	int		ipmi_items_num;
 	int		jmx_items_num;
 
-	/* timestamp of last availability status (available/error) field change on any interface */
-	int		availability_ts;
-
 	unsigned char	maintenance_status;
 	unsigned char	maintenance_type;
 	unsigned char	available;
@@ -310,9 +319,6 @@ typedef struct
 	unsigned char	jmx_available;
 	unsigned char	status;
 
-	/* flag to reset host availability to unknown */
-	unsigned char	reset_availability;
-
 	/* flag to force update for all items */
 	unsigned char	update_items;
 
@@ -631,7 +637,6 @@ zbx_dc_preproc_op_t;
 typedef struct
 {
 	/* timestamp of the last host availability diff sent to sever, used only by proxies */
-	int			availability_diff_ts;
 	int			proxy_lastaccess_ts;
 	int			sync_ts;
 	int			item_sync_ts;
@@ -684,6 +689,8 @@ typedef struct
 	zbx_hashset_t		hostgroups;
 	zbx_vector_ptr_t	hostgroups_name; 	/* host groups sorted by name */
 	zbx_hashset_t		preprocops;
+	zbx_hashset_t		hosts_ifstatus;		/* interface status for passive items by hosts */
+	zbx_hashset_t		hosts_availability;	/* hostids with modified availability */
 #if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_hashset_t		psks;			/* for keeping PSK-identity and PSK pairs and for searching */
 							/* by PSK identity */
diff --git a/src/libs/zbxdbcache/dbconfig_dump.c b/src/libs/zbxdbcache/dbconfig_dump.c
index 3260472..dbaf890 100644
--- a/src/libs/zbxdbcache/dbconfig_dump.c
+++ b/src/libs/zbxdbcache/dbconfig_dump.c
@@ -99,19 +99,14 @@ static void	DCdump_hosts(ZBX_DC_CONFIG *config)
 		zabbix_log(LOG_LEVEL_TRACE, "  proxy_hostid:%d", host->proxy_hostid);
 		zabbix_log(LOG_LEVEL_TRACE, "  data_expected_from:%d", host->data_expected_from);
 
-		zabbix_log(LOG_LEVEL_TRACE, "  zabbix:[available:%u, errors_from:%d disable_until:%d error:'%s']",
-				host->available, host->errors_from, host->disable_until, host->error);
-		zabbix_log(LOG_LEVEL_TRACE, "  snmp:[available:%u, errors_from:%d disable_until:%d error:'%s']",
-				host->snmp_available, host->snmp_errors_from, host->snmp_disable_until,
-				host->snmp_error);
-		zabbix_log(LOG_LEVEL_TRACE, "  ipmi:[available:%u, errors_from:%d disable_until:%d error:'%s']",
-				host->ipmi_available, host->ipmi_errors_from, host->ipmi_disable_until,
-				host->ipmi_error);
-		zabbix_log(LOG_LEVEL_TRACE, "  jmx:[available:%u, errors_from:%d disable_until:%d error:'%s']",
-				host->jmx_available, host->jmx_errors_from, host->jmx_disable_until, host->jmx_error);
-
-		/* timestamp of last availability status (available/error) field change on any interface */
-		zabbix_log(LOG_LEVEL_TRACE, "  availability_ts:%d", host->availability_ts);
+		zabbix_log(LOG_LEVEL_TRACE, "  zabbix:[available:%u, error:'%s']",
+				host->available, host->error);
+		zabbix_log(LOG_LEVEL_TRACE, "  snmp:[available:%u, error:'%s']",
+				host->snmp_available, host->snmp_error);
+		zabbix_log(LOG_LEVEL_TRACE, "  ipmi:[available:%u, error:'%s']",
+				host->ipmi_available, host->ipmi_error);
+		zabbix_log(LOG_LEVEL_TRACE, "  jmx:[available:%u, error:'%s']",
+				host->jmx_available, host->jmx_error);
 
 		zabbix_log(LOG_LEVEL_TRACE, "  maintenance_status:%u maintenance_type:%u maintenance_from:%d",
 				host->maintenance_status, host->maintenance_type, host->maintenance_from);
